package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.MajorCategory;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.MajorProjectAddBo;
import com.zhongzheng.modules.course.bo.MajorProjectQueryBo;
import com.zhongzheng.modules.course.bo.MajorProjectEditBo;
import com.zhongzheng.modules.course.domain.MajorProject;
import com.zhongzheng.modules.course.mapper.MajorProjectMapper;
import com.zhongzheng.modules.course.vo.MajorProjectVo;
import com.zhongzheng.modules.course.service.IMajorProjectService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 科目绑定项目Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-09
 */
@Service
public class MajorProjectServiceImpl extends ServiceImpl<MajorProjectMapper, MajorProject> implements IMajorProjectService {

    @Override
    public MajorProjectVo queryById(Long id){
        MajorProject db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, MajorProjectVo.class);
    }

    @Override
    public List<MajorProjectVo> queryList(MajorProjectQueryBo bo) {
        LambdaQueryWrapper<MajorProject> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getProjectId() != null, MajorProject::getProjectId, bo.getProjectId());
        lqw.eq(bo.getMajorId() != null, MajorProject::getMajorId, bo.getMajorId());
        lqw.orderByDesc(MajorProject::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<MajorProjectVo> entity2Vo(Collection<MajorProject> collection) {
        List<MajorProjectVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, MajorProjectVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<MajorProject> page = (Page<MajorProject>)collection;
            Page<MajorProjectVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(MajorProjectAddBo bo) {
        MajorProject add = BeanUtil.toBean(bo, MajorProject.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(MajorProjectEditBo bo) {
        MajorProject update = BeanUtil.toBean(bo, MajorProject.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(MajorProject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
